abuild.in 54.6 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# abuild - build apk packages (light version of makepkg)
4
# Copyright (c) 2008-2015 Natanael Copa <ncopa@alpinelinux.org>
Natanael Copa's avatar
Natanael Copa committed
5 6 7 8
#
# Distributed under GPL-2
#

9
program_version=@VERSION@
Natanael Copa's avatar
Natanael Copa committed
10
sysconfdir=@sysconfdir@
11
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
12
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
13

14
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
15

16 17 18 19 20 21
if ! [ -f "$datadir/functions.sh" ]; then
	echo "$datadir/functions.sh: not found" >&2
	exit 1
fi
. "$datadir/functions.sh"

Natanael Copa's avatar
Natanael Copa committed
22
# defaults
23
BUILD_BASE="build-base"
24

25 26 27 28 29
: ${FAKEROOT:="fakeroot"}
: ${SUDO_APK:="abuild-apk"}
: ${APK:="apk"}
: ${ADDUSER:="abuild-adduser"}
: ${ADDGROUP:="abuild-addgroup"}
30

31
apk_opt_wait="--wait 30"
32

33 34 35 36 37
# run optional log command for remote logging
logcmd() {
	${ABUILD_LOG_CMD:-true} "$@"
	return 0
}
Natanael Copa's avatar
Natanael Copa committed
38

39
# we override the default msg, warning and error as we want the pkgname
Natanael Copa's avatar
Natanael Copa committed
40
msg() {
41
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
42 43 44
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
45 46 47
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

Natanael Copa's avatar
Natanael Copa committed
48 49 50 51
warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
52 53 54
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

Natanael Copa's avatar
Natanael Copa committed
55 56 57 58
error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
59
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
60
	logcmd "ERROR: $pkgname: $1"
61 62
}

63 64 65 66
cross_compiling() {
	test "$CBUILD" != "$CHOST" -a -n "$CBUILDROOT"
}

Linux User's avatar
Linux User committed
67
cleanup() {
68
	local i=
Linux User's avatar
Linux User committed
69
	set_xterm_title ""
70 71 72
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
73 74 75 76 77 78 79
	for i; do
		case $i in
		pkgdir) msg "Cleaning up pkgdir"; rm -rf "$pkgbasedir";;
		srcdir) msg "Cleaning up srcdir"; rm -rf "$srcdir";;
		deps)
			if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
				msg "Uninstalling dependencies..."
80
				$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
81
				if cross_compiling; then
82 83 84 85
					$SUDO_APK del --root "$CBUILDROOT" \
						--quiet $apk_opt_wait \
						$uninstall_after
				fi
86 87 88 89
			fi
			;;
		esac
	done
Linux User's avatar
Linux User committed
90 91
}

Natanael Copa's avatar
Natanael Copa committed
92
die() {
Linux User's avatar
Linux User committed
93
	error "$@"
94
	cleanup $ERROR_CLEANUP
Natanael Copa's avatar
Natanael Copa committed
95 96 97
	exit 1
}

98 99 100 101
spell_error() {
	die "APKBUILD contains '$1'. It should be '$2'"
}

102
# check if apkbuild is basicly sane
103
default_sanitycheck() {
104
	local i= j= suggestion=
105
	msg "Checking sanity of $APKBUILD..."
106 107 108
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
109
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
110
		$APK version --check --quiet "$pkgver" ||\
111 112
			die "$pkgver is not a valid version"
	fi
113
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
114 115 116
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"
117 118 119
	if [ $(echo "$pkgdesc" | wc -c) -gt 128 ]; then
		die "pkgdesc is too long"
	fi
120
	is_function package || warning "Missing package() function in APKBUILD"
121

122 123
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
124 125
		die "replaces_priority must be a number"
	fi
126 127 128 129 130 131 132
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

133
	# check if CARCH, CBUILD, CHOST and CTARGET is set
134 135
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

136
	if [ -z "$CARCH" ]; then
Natanael Copa's avatar
Natanael Copa committed
137
		die "Please fix CHOST, or set CARCH in abuild.conf"
138
	fi
139

Natanael Copa's avatar
Natanael Copa committed
140
	for i in $install; do
141
		local n=${i%.*}
142
		local suff=${i##*.}
143 144 145 146 147
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
148
			die "$i: install script does not match pkgname or any subpackage"
149
		fi
150
		[ -e "$startdir/$i" ] || die "install script $i is missing"
151 152 153 154 155 156
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
157
	done
158

159 160 161
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
162
		[ "$f" = "$i" ] && die "$f: triggers must contain '='"
163 164 165 166
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
167

168 169
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
170 171
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
172 173 174 175
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
176
			case "$i" in
177
				*::*) i=${i%%::*};;
178
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
179
			esac
180 181
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
182 183 184 185 186 187 188 189 190 191

			# verify that our source does not have git tag version
			# name as tarball (typicallly github)
			if is_remote "$i" && [ "${i#*::}" = "$i" ]; then
				case ${i##*/} in
				v$pkgver.tar.*|$pkgver.tar.*)
					die "source ${i##*/} needs to be renamed to avoid possible collisions"
					;;
				esac
			fi
192 193
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
194

195 196 197 198 199 200 201 202
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
203
		done
204
	done
205

206
	# common spelling errors
207 208 209 210 211
	[ -n "$depend" ] && spell_error depend depends
	[ -n "$makedepend" ] && spell_error makedepend makedepends
	[ -n "$pkguser" ] && spell_error pkguser pkgusers
	[ -n "$pkggroup" ] && spell_error pkggroup pkggroups
	[ -n "$subpackage" ] && spell_error subpackage subpackages
Natanael Copa's avatar
Natanael Copa committed
212

213
	check_maintainer || die "Provide a valid RFC822 maintainer address"
214

215 216
	check_depends_dev || warning "depends_dev found but no development subpackage found"

217
	makedepends_has 'g++' && warning "g++ should not be in makedepends"
218 219 220
	return 0
}

221 222 223 224
sanitycheck() {
	default_sanitycheck
}

225 226
sumcheck() {
	local algo="$1" sums="$2"
227
	local dummy f endreturnval originalparams origin file
228 229 230 231 232 233 234 235

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
236
	fi
237
	fetch || return 1
238
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
239
	cd "$srcdir" || return 1
240 241
	IFS=$'\n'
	endreturnval=0
242
	for src in $sums; do
243
		origin=$1; shift
244
		echo "$src" | ${algo}sum -c
245
		if [ $? -ne 0 ]; then
246
			endreturnval=1
247
			is_remote $origin || continue
248
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
249 250 251 252 253 254 255 256
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
257 258
}

259 260 261 262 263 264 265 266 267
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
268
	for algo in sha512 sha256 sha1 md5; do
269 270 271 272 273 274 275
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
276
		break
277 278 279 280 281 282 283
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

284 285
# verify upstream sources
sourcecheck() {
286 287 288 289 290 291 292 293
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
294 295 296
		*::*)
			uri=${uri##*::}
			;;
297 298
		esac
		wget -q -s "$uri" || return 1
299
	done
300
	return 0
301
}
302

Natanael Copa's avatar
Natanael Copa committed
303 304
uri_fetch() {
	local uri="$1"
305
	[ -n "$quiet" ] && opts="-s"
306

Natanael Copa's avatar
Natanael Copa committed
307
	mkdir -p "$SRCDEST"
308
	abuild-fetch -d "$SRCDEST" "$uri"
Natanael Copa's avatar
Natanael Copa committed
309 310
}

311
is_remote() {
312
	case "${1#*::}" in
313
		http://*|ftp://*|https://*|saveas-*://*)
314 315 316 317 318
			return 0;;
	esac
	return 1
}

319 320 321 322 323 324 325 326 327
filename_from_uri() {
	local uri="$1"
	local filename="${uri##*/}"  # $(basename $uri)
	case "$uri" in
	*::*) filename=${uri%%::*};;
	esac
	echo "$filename"
}

328 329 330 331
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	if [ -n "$DISTFILES_MIRROR" ]; then
332
		if is_remote "$DISTFILES_MIRROR"; then
333 334
			uri_fetch "$DISTFILES_MIRROR"/$(filename_from_uri $uri)\
				&& return 0
335
		else
336 337
			cp "$DISTFILES_MIRROR"/$(filename_from_uri $uri) \
				"$SRCDEST" && return 0
338
		fi
339 340 341 342
	fi
	uri_fetch "$uri"
}

343
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
344 345
	local s
	mkdir -p "$srcdir"
346 347
	for s in $source; do
		if is_remote "$s"; then
348
			uri_fetch_mirror "$s" || return 1
349
			ln -sf "$SRCDEST/$(filename_from_uri $s)" "$srcdir"/
350
		else
351 352
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
353 354 355
	done
}

356 357 358 359
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
360 361
# verify that all init.d scripts are openrc runscripts
initdcheck() {
362
	local i line
Natanael Copa's avatar
Natanael Copa committed
363 364
	for i in $source; do
		case $i in
365 366 367 368 369 370 371 372 373 374 375
		*.initd) line=$(head -n 1 "$srcdir"/$i);;
		*) continue ;;
		esac

		case "$line" in
		*sbin/openrc-run)
			;;
		*sbin/runscript)
			warning "$i is not an openrc #!/sbin/openrc-run"
			;;
		*)	error "$i is not an openrc #!/sbin/openrc-run"
Natanael Copa's avatar
Natanael Copa committed
376 377 378
			return 1
			;;
		esac
379
	done
Natanael Copa's avatar
Natanael Copa committed
380 381
}

Natanael Copa's avatar
Natanael Copa committed
382
# unpack the sources
383
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
384
	local u
385
	if [ -z "$force" ]; then
386
		verify || return 1
Natanael Copa's avatar
Natanael Copa committed
387
		initdcheck || return 1
388
	fi
Natanael Copa's avatar
Natanael Copa committed
389 390
	mkdir -p "$srcdir"
	for u in $source; do
391
		local s="$SRCDEST/$(filename_from_uri $u)"
Natanael Copa's avatar
Natanael Copa committed
392
		case "$s" in
393 394 395
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
396
			*.tar.gz|*.tgz)
397
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
398 399
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
400
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
401
				tar -C "$srcdir" -jxf "$s" || return 1;;
402 403 404 405
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
406 407 408
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
409 410 411
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
412 413 414 415
		esac
	done
}

416 417 418 419
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
420 421
# cleanup source and package dir
clean() {
422
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
423
	rm -rf "$srcdir"
424
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
425 426 427 428 429 430
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
431
		if is_remote "$s"; then
432 433 434
			s=$(filename_from_uri $s)
			msg "Cleaning downloaded $s ..."
			rm -f "$SRCDEST/$s"
435
		fi
Natanael Copa's avatar
Natanael Copa committed
436 437 438
	done
}

439 440 441 442 443 444 445 446 447 448
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
449 450
cleanpkg() {
	local i
451
	getpkgver || return 1
452
	msg "Cleaning built packages..."
453
	for i in $(listpkgnames); do
454 455
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
456
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
457
	done
458
	# remove given packages from index
459
	update_abuildrepo_index
Natanael Copa's avatar
Natanael Copa committed
460 461
}

462 463 464
# clean all packages except current
cleanoldpkg() {
	local i j
465
	getpkgver || return 1
466
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
467
	for i in $(listpkgnames); do
468 469 470 471 472
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
473 474
		done
	done
475
	update_abuildrepo_index
476 477
	return 0
}
478 479 480

mkusers() {
	local i
481 482 483 484 485 486
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
487 488
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
489
			local gopt=
490
			msg "Creating user $i"
491 492 493
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
494
			$ADDUSER -S -D -H $gopt $i || return 1
495 496 497 498
		fi
	done
}

Natanael Copa's avatar
Natanael Copa committed
499 500
# helper to update config.sub to a recent version
update_config_sub() {
501
	local changed=false
Natanael Copa's avatar
Natanael Copa committed
502
	find . -name config.sub | while read f; do
503 504
		if ! ./$f armv6-alpine-linux-muslgnueabihf 2>/dev/null; then
			msg "Updating $f"
505 506 507
			cp "$datadir"/${f##*/} "$f" || return 1
			changed=true
		else
508
			msg "No update needed for $f"
509 510 511
		fi
		# pipe subshell will return status of last command
		$changed
Natanael Copa's avatar
Natanael Copa committed
512
	done
513
	return $?
Natanael Copa's avatar
Natanael Copa committed
514
}
515

Natanael Copa's avatar
Natanael Copa committed
516 517
runpart() {
	local part=$1
518
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
519 520 521 522
	$part || die "$part failed"
}

# override those in your build script
523 524 525 526 527 528 529 530
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

531 532 533 534 535 536 537 538 539 540 541 542 543
default_prepare() {
	local i
	cd "$_builddir"
	for i in $source; do
		case $i in
			*.patch)
				msg "$i"
				patch -p1 -i "$srcdir/$i" || return 1
				;;
		esac
	done
}

Natanael Copa's avatar
Natanael Copa committed
544
prepare() {
545
	default_prepare
Natanael Copa's avatar
Natanael Copa committed
546 547
}

Natanael Copa's avatar
Natanael Copa committed
548
build() {
549
	:
Natanael Copa's avatar
Natanael Copa committed
550 551
}

552 553 554
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
555
	mkdir -p "$PKGDEST"
556 557 558
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

559 560 561 562 563 564 565 566 567
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

568 569 570
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
571
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
572 573 574 575 576 577 578
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
579 580 581 582
		if [ -d "$dir"/usr/var ]; then
			error "Found /usr/var, localstatedir is most likely wrong"
			return 1
		fi
Natanael Copa's avatar
Natanael Copa committed
583
	fi
584 585 586 587

	# remove *.la files if libtool is not set
	if ! options_has "libtool"; then
		find "$dir" -name '*.la' -type f -delete
588
	fi
589

590 591 592 593 594 595
	# look for /usr/lib/charset.alias
	if [ -e "$dir"/usr/lib/charset.alias ] \
			&& ! options_has "charset.alias"; then
		error "Found /usr/lib/charset.alias"
		return 1
	fi
596 597
	# look for /usr/share/doc
	if [ -e "$dir"/usr/share/doc ] \
598
			&& ! is_doc_pkg "$name"; then
599 600 601
		warning "Found /usr/share/doc but package name doesn't end with -doc"
	fi
	# look for /usr/share/man
602
	if [ -e "$dir"/usr/share/man ]; then
603
		if ! is_doc_pkg "$name"; then
604 605
			warning "Found /usr/share/man but package name doesn't end with -doc"
		fi
606
		# check for uncompressed man pages
607
		i=$(find "$dir"/usr/share/man -name '*.[0-8]' -type f | sed "s|^$dir|\t|")
608 609 610 611 612 613
		if [ -n "$i" ]; then
			error "Found uncompressed man pages:"
			echo "$i"
			return 1
		fi
	fi
614 615 616 617 618 619
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
620
	# check so we dont have any suid root binaries that are not PIE
621
	i=$(find "$dir" -type f -perm /6000 \
622 623 624 625 626 627 628
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
629 630 631 632 633 634 635 636 637 638 639
	# test suid bit on executable
	if ! options_has "suid"; then
		i=$(find "$dir" \( -perm -u+s -o -perm -g+s \) -a -type f \
			-a -perm -o+x)
		if [ -n "$i" ]; then
			error "Found executable files with SUID bit set:"
			echo "$i"
			return 1
		fi
	fi

640 641 642 643 644 645 646 647 648
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
649 650 651
	return 0
}

652 653 654 655 656 657 658
pre_split() {
	if [ -z "$subpkgname" ]; then
		return 0
	fi
	# the subpackages should not inherit those form main package
	provides=""
	install_if=""
659
	apkbuild_arch="$arch"
660 661
}

662
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
663 664
	local i
	cd "$startdir"
665
	for i in $subpackages; do
666 667
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
668
		msg "Running split function $func..."
669
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
670
		( subpkgdir="$dir" subpkgname="$name" \
671
			$0 pre_split $func prepare_package \
672
			&& postcheck "$dir" "$name" ) || return 1
Natanael Copa's avatar
Natanael Copa committed
673
	done
674
	postcheck "$pkgdir" "$pkgname" || return 1
675 676
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
677
		warning "Found /usr/share/locale"
678
		warning2 "Maybe add \$pkgname-lang to subpackages?"
679
	fi
Natanael Copa's avatar
Natanael Copa committed
680 681
}

682
default_lang() {
683
	pkgdesc="Languages for package $pkgname"
684 685 686 687 688 689 690 691 692 693 694 695 696
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

697
default_lang_subpkg() {
698 699 700 701
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
702
	pkgdesc="$pkgname language pack for $lang"
703 704
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
705 706 707 708 709
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
710
		|| return 1
711 712 713 714 715
	done
}

lang_subpkg() {
	default_lang_subpkg
716 717 718 719 720 721 722 723 724 725 726
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

727 728 729 730 731 732 733 734 735 736 737 738
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

739 740 741
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
742 743
		# remove surrounding whitespace
		maintainer=$(echo "$maintainer" | xargs)
744 745 746
	fi
}

747 748


749 750 751 752 753 754 755 756 757 758
check_maintainer() {
	get_maintainer
	if [ -z "$maintainer" ]; then
		warning "No maintainer"
	else
		# try to check for a valid rfc822 address
		case "$maintainer" in
			*[A-Za-z0-9]*\ \<*@*.*\>) ;;
			*) return 1 ;;
		esac
759 760 761
	fi
}

762
check_depends_dev() {
763 764
	if [ -z "$depends_dev" ]; then
		return 0
765
	fi
766 767 768 769 770 771 772
	local i
	for i in $pkgname $subpackages; do
		case "$i" in
			*-dev)  return 0 ;;
		esac
	done
	return 1
773 774
}

775
prepare_metafiles() {
776
	getpkgver || return 1
777 778
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
779
	local dir=${subpkgdir:-$pkgdir}
780
	local pkg="$name-$pkgver-r$pkgrel.apk"
781
	local pkginfo="$controldir"/.PKGINFO
782
	local sub
783

Natanael Copa's avatar
Natanael Copa committed
784 785
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
786
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
787 788
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
789
	local parch="$CARCH"
790 791 792 793 794

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
795

796 797 798 799 800
	# save arch incase subpackages set it different than main pkg
	if [ "${apkbuild_arch:-$arch}" != "$arch" ]; then
		echo "$arch" > "$controldir"/.arch
	fi

801
	echo "# Generated by $(basename $0) $program_version" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
802
	if [ -n "$FAKEROOTKEY" ]; then
803
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
804
	fi
805 806
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
807
pkgname = $name
808
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
809 810 811 812 813
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
814
arch = $parch
815
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
816
EOF
817 818
	local i deps
	deps="$depends"
819
	if [ "$pkgname" != "busybox" ] && ! depends_has busybox; then
820 821
		for i in $install $triggers; do
			local s=${i%=*}
822
			[ "$name" != "${s%.*}" ] && continue
823
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
824 825 826 827 828
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
829
	fi
830

831 832 833
	# store last_commit in global var so we only call git once
	if [ -z "$last_commit" ]; then
		last_commit="$(git_last_commit)$(git_dirty)"
834
	fi
835
	echo "commit = $last_commit" >> "$pkginfo"
836

837
	get_maintainer
838 839 840 841
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

842
	if [ -n "$replaces_priority" ]; then
843
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
844 845
	fi

846
	echo "license = $license" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
847
	for i in $replaces; do
848
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
849
	done
850
	for i in $deps; do
851
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
852 853
	done
	for i in $provides; do
854
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
855
	done
856 857 858 859 860 861
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
862 863 864
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
865 866

	local metafiles=".PKGINFO"
867 868 869
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
870
		if [ "$n" != "$name" ]; then
871 872
			continue
		fi
873
		script=${f#$name}
874
		msg "Adding $script"
875
		cp "$startdir/$f" "$controldir/$script" || return 1
876
		chmod +x "$controldir/$script"
877 878
		metafiles="$metafiles $script"
	done
879
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
880
}
881

882
prepare_trace_rpaths() {
883
	local dir=${subpkgdir:-$pkgdir}
884
	local etype= soname= file= sover=
885
	[ "$arch" = "noarch" ] && return 0
886
	options_has "!tracedeps" && return 0
887
	# lets tell all the places we should look for .so files - all rpaths
888 889
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
890
		>"$controldir"/.rpaths
891
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
892
		warning "Redundant /usr/lib in rpath found"
893 894 895 896 897
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
898 899
}

900 901
# search for broken symlinks so we later can pull in proper depends
prepare_symlinks() {
902
	local target
903 904 905 906
	local dir="${subpkgdir:-$pkgdir}"
	options_has "!tracedeps" && return 0
	cd "$dir" || return 1
	find -type l | while read symlink; do
907 908 909
		target=$(readlink "$symlink")
		if ! [ -e "$dir$(normalize_target_path "$target" "$symlink")" ]; then
			echo "$symlink $target" >> "$controldir"/.symlinks
910 911 912 913
		fi
	done
}

914 915 916 917 918 919 920 921 922 923
prepare_pkgconfig_provides() {
	local dir="${subpkgdir:-$pkgdir}"
	options_has "!tracedeps" && return 0
	cd "$dir" || return 1
	for i in usr/lib/pkgconfig/*.pc; do
		if ! [ -e "$i" ]; then
			continue
		fi
		local f=${i##*/}
		local v=$(PKG_CONFIG_PATH="$dir"/usr/lib/pkgconfig pkg-config \
924
			--modversion ${f%.pc})
925 926 927 928
		echo "${f%.pc}=${v:-0}" >> "$controldir"/.provides-pc
	done
}

929 930 931 932 933 934 935 936 937 938 939 940
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

941 942 943 944 945
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

946 947
# returns true if this is the -doc package
is_doc_pkg() {
948
	test "${1%-doc}" != "$1"
949 950
}

951 952 953 954 955 956 957
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
958 959 960
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
961 962 963 964
	fi
	return 0
}

965
prepare_package() {
966
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
967
	stripbin
968 969 970 971
	prepare_metafiles \
		&& prepare_trace_rpaths \
		&& prepare_symlinks \
		&& prepare_pkgconfig_provides \
972
		|| return 1
973
	archcheck
974 975 976 977 978 979 980 981
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

982 983 984 985 986 987 988 989 990 991 992 993 994 995 996 997 998 999 1000 1001 1002 1003 1004
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

1005 1006 1007 1008 1009
subpkg_provides_prefixed_so() {
	[ -n "$sonameprefix" ] && grep -q -w "^$sonameprefix$1" \
		"$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

1010
subpkg_provides_so() {
1011 1012 1013
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

1014
subpkg_provides_pc() {
1015 1016
	grep -q -w "^${1%%[<>=]*}" "$pkgbasedir"/.control.*/.provides-pc \
		2>/dev/null
1017 1018
}

1019 1020 1021
trace_apk_deps() {
	local name="$1"
	local dir="$2"
1022
	local i= found= autodeps= deppkgs= missing=
1023
	msg "Tracing dependencies..."
1024 1025 1026
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
1027 1028 1029 1030
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
1031 1032
	if [ "$CLIBC" = "uclibc" ] && [ -f "$dir"/.needs-so ] \
			&& grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
1033 1034
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
1035
		msg "  added libgcc (due to libpthread)"
1036
	fi
1037

1038
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
1039
		# first check if its provided by same apkbuild
1040
		grep -q -w "^$sonameprefix$i" "$dir"/.provides-so 2>/dev/null && continue
1041

1042 1043 1044
		if subpkg_provides_prefixed_so "$i"; then
			autodeps="$autodeps so:$sonameprefix$i"
		elif subpkg_provides_so "$i" || cross_compiling \
1045
				|| $APK info --quiet --installed "so:$i"; then
1046
			autodeps="$autodeps so:$i"
1047
		else
1048
			missing="$missing $i"
1049
		fi
1050 1051 1052
	done

	# find all packages that holds the so files
1053
	if [ -f "$dir"/.rpaths ]; then
1054 1055
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
1056
		deppkgs=$($APK info --quiet --who-owns $so_files) || return 1
1057 1058
	fi

1059
	for found in $deppkgs; do
1060
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
1061 1062 1063
			warning "You can remove '$found' from depends"
			continue
		fi
1064
		autodeps="$autodeps $found"
1065
	done
1066

1067 1068 1069 1070 1071
	# symlink targets
	for i in $(sort -u "$dir"/.symlinks-needs 2>/dev/null); do
		autodeps="$autodeps $i"
	done

1072 1073 1074 1075
	# pkg-config depends
	for i in $(sort -u "$dir"/.needs-pc 2>/dev/null); do
		if subpkg_provides_pc "$i" || cross_compiling \
				|| $APK info --quiet --installed "pc:$i"; then
1076 1077 1078 1079
			local provider=$(apk search --quiet "pc:$i")
			if list_has "$provider" $depends_dev; then
				warning "$provider should be removed from depends_dev"
			fi
1080
			autodeps="$autodeps pc:$i"
1081 1082 1083 1084 1085 1086 1087
		else
			warning "Could not find any provider for pc:$i"
			local pcfile=/usr/lib/pkgconfig/"${i%%[<>=]*}".pc
			if [ -e "$pcfile" ]; then
				local owner=$($APK info --quiet --who-owns $pcfile)
				warning "${owner:-package providing $pcfile} needs to be rebuilt"
			fi
1088 1089 1090
		fi
	done

1091
	echo "# automatically detected:" >> "$dir"/.PKGINFO
1092
	if [ -f "$dir"/.provides-so ]; then
1093 1094
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' \
			"$dir"/.provides-so | sort -u \
1095
			>> "$dir"/.PKGINFO
1096
	fi
1097
	if [ -f "$dir"/.provides-pc ]; then
1098
		sed 's/^/provides = pc:/' "$dir"/.provides-pc | sort -u \
1099 1100
			>> "$dir"/.PKGINFO
	fi
1101
	[ -z "$autodeps" ] && return 0
1102
	for i in $autodeps; do
1103 1104
		echo "depend = $i"
	done | sort -u >> "$dir"/.PKGINFO
1105 1106
	# display all depends
	sed -n '/^depend =/s/depend = /\t/p' "$dir"/.PKGINFO >&2
1107 1108